# std::hash<Key>::operator()

From cppreference.com
< cpp‎ | utility‎ | hash

Specializations of std::hash should define an `operator()` that:

- Takes a single argument `key` of type `Key`.
- Returns a value of type std::size_t that represents the hash value of `key`.
- For two parameters `k1` and `k2` that are equal, std::hash<Key>()(k1) == std::hash<Key>()(k2).
- For two different parameters `k1` and `k2` that are not equal, the probability that std::hash<Key>()(k1) == std::hash<Key>()(k2) should be very small, approaching 1.0/std::numeric_limits<size_t>::max().

### Parameters

key | - | the object to be hashed

### Return value

a std::size_t representing the hash value

### Exceptions

Hash functions should not throw exceptions.

### Example

The following code shows how to specialize the std::hash template for a custom class.

Run this code

    #include <functional>
    #include <iostream>
    #include <string>

    struct Employee {
      std::string name;
      unsigned int ID;
    };

    namespace std {
    template <>
    class hash<Employee> {
     public:
      size_t operator()(const Employee &employee) const
      {
        // computes the hash of an employee using a variant
        // of the Fowler-Noll-Vo hash function
        size_t result = 2166136261;

        for (size_t i = 0, ie = employee.name.size(); i != ie; ++i) {
          result = (result * 16777619) ^ employee.name[i];
        }

        return result ^ (employee.ID << 1);
      }
    };
    }

    int main()
    {
      Employee employee;
      employee.name = "Zaphod Beeblebrox";
      employee.ID = 42;

      std::hash<Employee> hash_fn;
      std::cout << hash_fn(employee) << '\n';
    }

Output:

    177237019

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/utility/hash/operator()&oldid=74349"